archerysec/projects/urls.py
# -*- coding: utf-8 -*-
#                    _
#     /\            | |
#    /  \   _ __ ___| |__   ___ _ __ _   _
#   / /\ \ | '__/ __| '_ \ / _ \ '__| | | |
#  / ____ \| | | (__| | | |  __/ |  | |_| |
# /_/    \_\_|  \___|_| |_|\___|_|   \__, |
#                                     __/ |
#                                    |___/
# Copyright (C) 2017 Anand Tiwari
#
# Email:   anandtiwarics@gmail.com
# Twitter: @anandtiwarics
#
# This file is part of ArcherySec Project.

from django.urls import include, path
from projects import views

app_name = 'projects'

urlpatterns = [
    path('create/',
        views.create,
        name='create'),
    path('create_form/',
        views.create_form,
        name='create_form'),
    path('',
        views.projects,
        name='projects'),
    path('project_edit/',
        views.project_edit,
        name='project_edit'),
]

archerysec/tools/urls.py
# -*- coding: utf-8 -*-
#                    _
#     /\            | |
#    /  \   _ __ ___| |__   ___ _ __ _   _
#   / /\ \ | '__/ __| '_ \ / _ \ '__| | | |
#  / ____ \| | | (__| | | |  __/ |  | |_| |
# /_/    \_\_|  \___|_| |_|\___|_|   \__, |
#                                     __/ |
#                                    |___/
# Copyright (C) 2017 Anand Tiwari
#
# Email:   anandtiwarics@gmail.com
# Twitter: @anandtiwarics
#
# This file is part of ArcherySec Project.

from django.urls import include, path
from tools import views

app_name = 'tools'

urlpatterns = [
    path('sslscan/',
        views.sslscan,
        name='sslscan'),
    path('sslscan_result/',
        views.sslscan_result,
        name='sslscan_result'),
    path('sslcan_del/',
        views.sslcan_del,
        name='sslcan_del'),

    # Nikto requests
    path('nikto/',
        views.nikto,
        name='nikto'),
    path('nikto_result/',
        views.nikto_result,
        name='nikto_result'),
    path('nikto_scan_del/',
        views.nikto_scan_del,
        name='nikto_scan_del'),

    path('nikto_result_vul/',
        views.nikto_result_vul,
        name='nikto_result_vul'),
    path('nikto_vuln_del/',
        views.nikto_vuln_del,
        name='nikto_vuln_del'),

    # nmap requests
    path('nmap_scan/',
        views.nmap_scan,
        name='nmap_scan'),
    path('nmap/',
        views.nmap,
        name='nmap'),
    path('nmap_result/',
        views.nmap_result,
        name='nmap_result'),
    path('nmap_scan_del/',
        views.nmap_scan_del,
        name='nmap_scan_del'),

    #Nmap_Vulners
    path('nmap_vulners_scan/',
        views.nmap_vulners_scan,
        name='nmap_scan'),
    path('nmap_vulners/',
        views.nmap_vulners,
        name='nmap_vulners'),
    path('nmap_vulners_port_list/',
        views.nmap_vulners_port,
        name='nmap_vulners_port'),
]

archerysec/projects/models.py
# -*- coding: utf-8 -*-
#                    _
#     /\            | |
#    /  \   _ __ ___| |__   ___ _ __ _   _
#   / /\ \ | '__/ __| '_ \ / _ \ '__| | | |
#  / ____ \| | | (__| | | |  __/ |  | |_| |
# /_/    \_\_|  \___|_| |_|\___|_|   \__, |
#                                     __/ |
#                                    |___/
# Copyright (C) 2017 Anand Tiwari
#
# Email:   anandtiwarics@gmail.com
# Twitter: @anandtiwarics
#
# This file is part of ArcherySec Project.

from __future__ import unicode_literals

from django.db import models
from django.db.models import Func, F, Sum


class project_db(models.Model):
    project_id = models.TextField(blank=True)
    project_name = models.TextField(blank=True)
    project_start = models.TextField(blank=True)
    project_end = models.TextField(blank=True)
    project_owner = models.TextField(blank=True)
    project_disc = models.TextField(blank=True)
    project_status = models.TextField(blank=True)
    date_time = models.DateTimeField(null=True)
    total_vuln = models.IntegerField(blank=True, null=True)
    total_high = models.IntegerField(blank=True, null=True)
    total_medium = models.IntegerField(blank=True, null=True)
    total_low = models.IntegerField(blank=True, null=True)
    total_open = models.IntegerField(blank=True, null=True)
    total_false = models.IntegerField(blank=True, null=True)
    total_close = models.IntegerField(blank=True, null=True)
    total_net = models.IntegerField(blank=True, null=True)
    total_web = models.IntegerField(blank=True, null=True)
    total_static = models.IntegerField(blank=True, null=True)
    high_net = models.IntegerField(blank=True, null=True)
    high_web = models.IntegerField(blank=True, null=True)
    high_static = models.IntegerField(blank=True, null=True)
    medium_net = models.IntegerField(blank=True, null=True)
    medium_web = models.IntegerField(blank=True, null=True)
    medium_static = models.IntegerField(blank=True, null=True)
    low_net = models.IntegerField(blank=True, null=True)
    low_web = models.IntegerField(blank=True, null=True)
    low_static = models.IntegerField(blank=True, null=True)
    username = models.CharField(max_length=256, null=True)


class project_scan_db(models.Model):
    project_url = models.TextField(blank=True) #this is scan url
    project_ip = models.TextField(blank=True)
    scan_type = models.TextField(blank=True)
    project_id = models.TextField(blank=True)
    date_time = models.DateTimeField(null=True)


class Month(Func):
    function = 'EXTRACT'
    template = '%(function)s(MONTH from %(expressions)s)'
    output_field = models.IntegerField()

class MonthSqlite(Func):
    function = 'STRFTIME'
    template = '%(function)s("%%m", %(expressions)s)'
    output_field = models.CharField()

class month_db(models.Model):
    month = models.TextField(blank=True, null=True)
    high = models.IntegerField(blank=True, default=0)
    medium = models.IntegerField(blank=True, default=0)
    low = models.IntegerField(blank=True, default=0)
    project_id = models.TextField(blank=True, default=0)
    username = models.CharField(max_length=256, null=True)

archerysec/projects/views.py
# -*- coding: utf-8 -*-
#                    _
#     /\            | |
#    /  \   _ __ ___| |__   ___ _ __ _   _
#   / /\ \ | '__/ __| '_ \ / _ \ '__| | | |
#  / ____ \| | | (__| | | |  __/ |  | |_| |
# /_/    \_\_|  \___|_| |_|\___|_|   \__, |
#                                     __/ |
#                                    |___/
# Copyright (C) 2017 Anand Tiwari
#
# Email:   anandtiwarics@gmail.com
# Twitter: @anandtiwarics
#
# This file is part of ArcherySec Project.

from __future__ import unicode_literals
from django.shortcuts import render, HttpResponseRedirect
from django.contrib import messages
import uuid
from projects.models import project_db, project_scan_db
from webscanners.models import zap_scans_db, zap_scan_results_db, \
    burp_scan_db, burp_scan_result_db, \
    arachni_scan_db, arachni_scan_result_db, \
    netsparker_scan_db, netsparker_scan_result_db, \
    webinspect_scan_db, webinspect_scan_result_db, \
    acunetix_scan_db, acunetix_scan_result_db
from staticscanners.models import dependencycheck_scan_db, dependencycheck_scan_results_db, \
    findbugs_scan_db, findbugs_scan_results_db, \
    bandit_scan_db, bandit_scan_results_db, clair_scan_db, clair_scan_results_db, \
    trivy_scan_db, trivy_scan_results_db, npmaudit_scan_db, npmaudit_scan_results_db, nodejsscan_scan_results_db, \
    nodejsscan_scan_db, tfsec_scan_results_db, tfsec_scan_db, checkmarx_scan_results_db, checkmarx_scan_db, \
    whitesource_scan_db, whitesource_scan_results_db, gitlabsca_scan_results_db, gitlabsast_scan_results_db, \
    gitlabsca_scan_db, gitlabsast_scan_db, semgrepscan_scan_results_db, semgrepscan_scan_db, \
    gitlabcontainerscan_scan_results_db, gitlabcontainerscan_scan_db, \
        twistlock_scan_results_db, twistlock_scan_db, \
            brakeman_scan_db, brakeman_scan_results_db
from compliance.models import inspec_scan_results_db, inspec_scan_db, dockle_scan_db, dockle_scan_results_db
from networkscanners.models import openvas_scan_db, ov_scan_result_db, nessus_scan_db, nessus_targets_db, nessus_scan_results_db
import datetime
from manual_scan.models import manual_scan_results_db, manual_scans_db
from projects.models import month_db
from itertools import chain
from django.urls import reverse
from dashboard.scans_data import scans_query

project_dat = None


def create_form(request):
    return render(request, 'project_create.html')


def create(request):
    if request.method == 'POST':
        username = request.user.username
        print(username)
        project_id = uuid.uuid4()
        project_name = request.POST.get("projectname", )
        project_date = request.POST.get("projectstart", )
        project_end = request.POST.get("projectend", )
        project_owner = request.POST.get("projectowner", )
        project_disc = request.POST.get("project_disc", )
        date_time = datetime.datetime.now()

        save_project = project_db(username=username,
                                  project_name=project_name,
                                  project_id=project_id,
                                  project_start=project_date,
                                  project_end=project_end,
                                  project_owner=project_owner,
                                  project_disc=project_disc,
                                  date_time=date_time,
                                  total_vuln=0,
                                  total_high=0,
                                  total_medium=0,
                                  total_low=0,
                                  total_open=0,
                                  total_false=0,
                                  total_close=0,
                                  total_net=0,
                                  total_web=0,
                                  total_static=0,
                                  high_net=0,
                                  high_web=0,
                                  high_static=0,
                                  medium_net=0,
                                  medium_web=0,
                                  medium_static=0,
                                  low_net=0,
                                  low_web=0,
                                  low_static=0)
        save_project.save()

        messages.success(request, "Project Created")
        all_month_data_display = month_db.objects.filter(username=username)

        if len(all_month_data_display) == 0:
            save_months_data = month_db(username=username,
                                        project_id=project_id,
                                        month=datetime.datetime.now().month,
                                        high=0,
                                        medium=0,
                                        low=0
                                        )
            save_months_data.save()

        return HttpResponseRedirect(reverse('dashboard:dashboard'))

    return render(request, 'dashboard/project.html')


def projects(request):

    if request.method == 'POST':
        project_id = request.POST.get("proj_id", )

        del_proj = project_db.objects.filter(project_id=project_id)
        del_proj.delete()
        # add your scanner db models
        burp = burp_scan_db.objects.filter(project_id=project_id)
        burp.delete()
        burp_result_data = burp_scan_result_db.objects.filter(project_id=project_id)
        burp_result_data.delete()

        zap = zap_scans_db.objects.filter(project_id=project_id)
        zap.delete()
        zap_result = zap_scan_results_db.objects.filter(project_id=project_id)
        zap_result.delete()

        arachni = arachni_scan_db.objects.filter(project_id=project_id)
        arachni.delete()
        arachni_result = arachni_scan_result_db.objects.filter(project_id=project_id)
        arachni_result.delete()

        webinspect = webinspect_scan_db.objects.filter(project_id=project_id)
        webinspect.delete()
        webinspect_result = webinspect_scan_result_db.objects.filter(project_id=project_id)
        webinspect_result.delete()

        netsparker = netsparker_scan_db.objects.filter(project_id=project_id)
        netsparker.delete()
        netsparker_result = netsparker_scan_result_db.objects.filter(project_id=project_id)
        netsparker_result.delete()

        acunetix = acunetix_scan_db.objects.filter(project_id=project_id)
        acunetix.delete()
        acunetix_result = acunetix_scan_result_db.objects.filter(project_id=project_id)
        acunetix_result.delete()

        dependency_check = dependencycheck_scan_db.objects.filter(project_id=project_id)
        dependency_check.delete()
        dependency_check_result = dependencycheck_scan_results_db.objects.filter(project_id=project_id)
        dependency_check_result.delete()

        findbugs = findbugs_scan_db.objects.filter(project_id=project_id)
        findbugs.delete()
        findbugs_result = findbugs_scan_results_db.objects.filter(project_id=project_id)
        findbugs_result.delete()

        bandit = bandit_scan_db.objects.filter(project_id=project_id)
        bandit.delete()
        bandit_result = bandit_scan_results_db.objects.filter(project_id=project_id)
        bandit_result.delete()

        clair = clair_scan_db.objects.filter(project_id=project_id)
        clair.delete()
        clair_result = clair_scan_results_db.objects.filter(project_id=project_id)
        clair_result.delete()

        trivy = trivy_scan_db.objects.filter(project_id=project_id)
        trivy.delete()
        trivy_result = trivy_scan_results_db.objects.filter(project_id=project_id)
        trivy_result.delete()

        npmaudit = npmaudit_scan_db.objects.filter(project_id=project_id)
        npmaudit.delete()
        npmaudit_result = npmaudit_scan_results_db.objects.filter(project_id=project_id)
        npmaudit_result.delete()

        nodejsscan = nodejsscan_scan_db.objects.filter(project_id=project_id)
        nodejsscan.delete()
        nodejsscan_result = nodejsscan_scan_results_db.objects.filter(project_id=project_id)
        nodejsscan_result.delete()

        tfsec = tfsec_scan_db.objects.filter(project_id=project_id)
        tfsec.delete()
        tfsec_result = tfsec_scan_results_db.objects.filter(project_id=project_id)
        tfsec_result.delete()

        whitesource = whitesource_scan_db.objects.filter(project_id=project_id)
        whitesource.delete()
        whitesource_result = whitesource_scan_results_db.objects.filter(project_id=project_id)
        whitesource_result.delete()

        gitlabsca = gitlabsca_scan_db.objects.filter(project_id=project_id)
        gitlabsca.delete()
        gitlabsca_result = gitlabsca_scan_results_db.objects.filter(project_id=project_id)
        gitlabsca_result.delete()

        gitlabsast = gitlabsast_scan_db.objects.filter(project_id=project_id)
        gitlabsast.delete()
        gitlabsast_result = gitlabsast_scan_results_db.objects.filter(project_id=project_id)
        gitlabsast_result.delete()

        brakeman = brakeman_scan_db.objects.filter(project_id=project_id)
        brakeman.delete()
        brakeman_result = brakeman_scan_results_db.objects.filter(project_id=project_id)
        brakeman_result.delete()

        twistlock = twistlock_scan_db.objects.filter(project_id=project_id)
        twistlock.delete()
        twistlock_result = twistlock_scan_results_db.objects.filter(project_id=project_id)
        twistlock_result.delete()



        gitlabcontainerscan = gitlabcontainerscan_scan_db.objects.filter(project_id=project_id)
        gitlabcontainerscan.delete()
        gitlabcontainerscan_result = gitlabcontainerscan_scan_results_db.objects.filter(project_id=project_id)
        gitlabcontainerscan_result.delete()

        checkmarx = checkmarx_scan_db.objects.filter(project_id=project_id)
        checkmarx.delete()
        checkmarx_result = checkmarx_scan_results_db.objects.filter(project_id=project_id)

archerysec/projects/templates/project_create.html
{% extends 'dashboard/base.html' %}

{% block body %}

<div class="page-wrapper">
    <div class="container-fluid">
        <div class="row justify-content-md-center">
            <div class="col-8">
                <div class="card">
                    <div class="card-body">
                        <div class="d-md-flex align-items-center">
                            <h1 class="card-title">Create Project</h1>
                        </div>
                        <br>
                        <div class="card">
                            <div class="card-body">
                                <div class="col-md-12">
                                    <form class="form-horizontal" method="POST" action="{% url 'projects:create' %}">
                                        {% csrf_token %}
                                        <div class="form-group row">
                                            <label class="col-sm-4 col-form-label">Project Name :</label>
                                            <div class="col-sm-6">
                                                <input type="text" name="projectname" value="{{ projectname }}"
                                                       class="form-control"
                                                       placeholder="Project Name"/>
                                            </div>
                                        </div>

                                        <div class="form-group row">
                                            <label class="col-sm-4 col-form-label">Project Start Date :</label>
                                            <div class="col-sm-6">
                                                <input type="date" name="projectstart" value="{{ projectstart }}"
                                                       class="form-control"
                                                       placeholder="Project Start Date"/>
                                            </div>
                                        </div>
                                        <div class="form-group row">
                                            <label class="col-sm-4 col-form-label">Project End date :</label>
                                            <div class="col-sm-6">
                                                <input type="date" name="projectend" value="{{ projectend }}"
                                                       class="form-control"
                                                       placeholder="Project End date"/>
                                            </div>
                                        </div>
                                        <div class="form-group row">
                                            <label class="col-sm-4 col-form-label">Project Owner :</label>
                                            <div class="col-sm-6">
                                                <input type="text" name="projectowner" value="{{ projectowner }}"
                                                       class="form-control"
                                                       placeholder="Project Owner"/>
                                            </div>
                                        </div>
                                        <div class="form-group row">
                                            <label class="col-sm-4 col-form-label">Pentester :</label>
                                            <div class="col-sm-6">
                                                <input type="text" name="pentester" value="{{ pentester }}"
                                                       class="form-control"
                                                       placeholder="Pentester"/>
                                            </div>
                                        </div>
                                        <div class="form-group row">
                                            <label class="col-sm-4 col-form-label">Project Summary :</label>
                                            <div class="col-sm-6">
                                                <textarea name="project_disc" value="{{ project_disc }}"
                                                          class="form-control"
                                                          placeholder="Project Summary"/></textarea>
                                            </div>
                                        </div>
                                        <div class="form-actions">
                                            <button type="submit" class="btn btn-success">Save</button>
                                        </div>
                                    </form>
                                    <div class="card">
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

{% endblock %}

archerysec/projects/templates/project_edit.html
{% extends 'header.html' %}
{% block body %}

<div id="content">{% for data in project_dat %}
    <!--breadcrumbs-->
    <div id="content-header">
        <div id="breadcrumb"><a href="/" title="Go to Home" class="tip-bottom"><i class="icon-home"></i>
            Home</a></div>
    </div>
    <div class="container-fluid">
        <hr>
        <div class="row-fluid">
            <div class="span5 offset3">
                <div class="widget-box">
                    <div class="widget-title"><span class="icon"> <i class="icon-align-justify"></i> </span>
                        <h5>Edit Project</h5>
                    </div>
                    <div class="widget-content nopadding">
                        <form class="form-horizontal" method="POST" action="{% url 'projects:project_edit' %}">{% csrf_token %}
                            <input type="hidden" name="project_id" value="{{ data.project_id }}"/>
                            <div class="control-group">
                                <label class="control-label">Project Name :</label>
                                <div class="controls">
                                    <input type="text" name="projectname"
                                           value="{{ data.project_name }}" class="span11"/>
                                </div>
                            </div>
                            <div class="control-group">
                                <label class="control-label">Project Start Date :</label>
                                <div class="controls">
                                    <input type="date" name="projectstart"
                                           value="{{ data.project_start }}" class="span11"/>
                                </div>
                            </div>
                            <div class="control-group">
                                <label class="control-label">Project End date :</label>
                                <div class="controls">
                                    <input type="date" name="projectend"
                                           value="{{ data.project_end }}" class="span11"/>
                                </div>
                            </div>
                            <div class="control-group">
                                <label class="control-label">Project Owner :</label>
                                <div class="controls">
                                    <input type="text" name="projectowner"
                                           value="{{ data.project_owner }}" class="span11"/>
                                </div>
                            </div>
                            <div class="control-group">
                                <label class="control-label">Project Summary :</label>
                                <div class="controls">
                                    <textarea name="project_disc"
                                               class="span11"> {{data.project_disc}}</textarea>
                                </div>
                            </div>
                            <div class="form-actions">
                                <button type="submit" class="btn btn-success">Save</button>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

{% endfor %}

{% endblock %}

archerysec/projects/templates/projects.html
{% extends 'tablehead.html' %}
{% block body %}

<script>

<script src="https://code.jquery.com/jquery-1.12.4.min.js"></script>
<script type="text/javascript">


    $(document).on('click', '.confirm-delete', function(){
    return confirm('Are you sure you want to delete this?');
})

</script>

<div id="content">
    <div id="content-header">
        <div id="breadcrumb"><a href="/" title="Go to Home" class="tip-bottom"><i class="icon-home"></i> Home</a> <a
                href="#" class="current">Projects List</a></div>

        <h1>Projects List</h1>
    </div>

    <div class="container-fluid">
        <div class="row-fluid">
            <div class="span12">
            <div class="widget-box">
                <div class="widget-title"><span class="icon"><i class="icon-th"></i></span>
                    <h5>Project List</h5>
                    <div class="buttons"><a data-toggle="modal" href="/projects/create_form/"
                                            class="btn btn-primary btn-mini"><i
                            class="icon-plus icon-white"></i> Add new Project</a>
                    </div>
                </div>
                <div class="widget-content nopadding">
                    <table class="table table-bordered data-table">
                        <thead>
                        <tr>
                            <!--<th>ID</th>-->
                            <th>Project</th>
                            <th>Date Time</th>
                            <th>Project Start Date</th>
                            <th>Project End Date</th>
                            <th>Project Owner</th>
                            <th>Project Status</th>
                            <th>Action</th>
                        </tr>
                        </thead>
                        <tbody>{% for data in all_projects %}
                        <tr data-target="#">
                            <td><a href="projects_view/?proj_id={{data.project_id}}">{{data.project_name}}</a></td>
                            <td>{{data.date_time}}</td>
                            <td>{{data.project_start}}</td>
                            <td>{{data.project_end}}</td>
                            <td>{{data.project_owner}}</td>
                            <td>{{data.project_status}}</td>
                            <td class="confirm-delete">
                                <form action="/projects/" method="POST">
                                    <input type="hidden" name="proj_id" value="{{data.project_id}}"/>{% csrf_token %}
                                    <button class="btn btn-danger"><i class="icon-remove"></i></button>
                                </form>
                            </td>
                        </tr>
                        {% endfor %}
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
        </div>
    </div>
</div>
</div>

{% endblock %}